<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">
            <el-form-item label="数据来源" prop="dataSource">
              <el-select v-model="queryParams.dataSource" placeholder="请选择数据来源" @change="handleQuery">
                <el-option v-for="item in dataSourceOptions" :key="item.dataSourceNm" :label="item.dataSourceNm" :value="item.dataSourceNm" />
              </el-select>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
              <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:level:add']">新增</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header> 供应商等级信息列表 </template>

      <el-table v-loading="loading" border :data="levelList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="主键ID" align="center" prop="id" v-if="false" />
        <el-table-column label="编号" align="center" prop="supplierLevelNo" />
        <el-table-column label="名称" align="center" prop="supplierLevelName" />
        <el-table-column label="是否展示" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.isShow" active-value="1" inactive-value="0" @change="handleIsShowChange(scope.row)" />
          </template>
        </el-table-column>
        <!-- <el-table-column label="数据来源" align="center" prop="dataSource" /> -->
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:level:edit']"></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['system:level:remove']"></el-button>
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改供应商等级对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="levelFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="名称" prop="supplierLevelName">
          <el-input v-model="form.supplierLevelName" placeholder="请输入名称" />
        </el-form-item>
        <el-form-item label="是否展示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio value="1">是</el-radio>
            <el-radio value="0">否</el-radio>
          </el-radio-group>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="Level" lang="ts">
import { listLevel, getLevel, delLevel, addLevel, updateLevel, getDataSourceList } from '@/api/system/level';
import { LevelVO, LevelQuery, LevelForm } from '@/api/system/level/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const levelList = ref<LevelVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const dataSourceOptions = ref<{ dataSourceNm: string }[]>([]);

const queryFormRef = ref<ElFormInstance>();
const levelFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: LevelForm = {
  supplierLevelName: undefined,
  isShow: undefined
};
const data = reactive<PageData<LevelForm, LevelQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    dataSource: undefined,
    params: {}
  },
  rules: {
    supplierLevelName: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
    isShow: [{ required: true, message: '是否展示不能为空', trigger: 'blur' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询供应商等级列表 */
const getList = async () => {
  loading.value = true;
  const res = await listLevel(queryParams.value);
  levelList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  levelFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: LevelVO[]) => {
  ids.value = selection.map((item) => item.supplierLevelNo);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 是否展示状态修改 */
const handleIsShowChange = async (row: LevelVO) => {
  await updateLevel(row);
  proxy?.$modal.msgSuccess('修改成功');
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  form.value.dataSource = queryParams.value.dataSource;
  dialog.visible = true;
  dialog.title = '添加供应商等级';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: LevelVO) => {
  reset();
  const _datasource = row?.dataSource || queryParams.value.dataSource;
  const _supplierLevelNo = row?.supplierLevelNo || (ids.value[0] as string);
  const res = await getLevel(_datasource, _supplierLevelNo);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改供应商等级';
};

/** 提交按钮 */
const submitForm = () => {
  levelFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.supplierLevelNo) {
        await updateLevel(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addLevel(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: LevelVO) => {
  const _supplierLevelNos = row?.supplierLevelNo || ids.value;
  await proxy?.$modal.confirm('是否确认删除供应商等级编号为"' + _supplierLevelNos + '"的数据项？').finally(() => (loading.value = false));
  await delLevel(_supplierLevelNos);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/level/export',
    {
      ...queryParams.value
    },
    `level_${new Date().getTime()}.xlsx`
  );
};

/** 获取数据来源列表 */
const fetchDataSourceList = async () => {
  const res = await getDataSourceList();
  dataSourceOptions.value = res.data;
  // 默认选中第一个数据源
  if (dataSourceOptions.value.length > 0) {
    queryParams.value.dataSource = dataSourceOptions.value[1].dataSourceNm;
  }
};

onMounted(async () => {
  await fetchDataSourceList();
  getList();
});
</script>
